#include <stdio.h>
#include <stdlib.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "lib.h"
#include "asm_format.h"

void asm_format_label(FILE *out, char *label)
{
  fprintf(out, "%s:\n", label);
}

typedef enum {
  SECTION_TYPE_NONE,
  SECTION_TYPE_TEXT,
  SECTION_TYPE_DATA,
} section_type_t;

static section_type_t section_type = SECTION_TYPE_NONE;

static int format_section(FILE *out, section_type_t type)
{
  if (section_type != type) {
    fprintf(out, "\t.section\t");
    switch (type) {
    case SECTION_TYPE_TEXT: fprintf(out, ".text"); break;
    case SECTION_TYPE_DATA: fprintf(out, ".data"); break;
    case SECTION_TYPE_NONE:
      fprintf(out, "unknown");
      break;
    }
    fprintf(out, "\n\n");
  }

  return section_type = type;
}

int asm_format_section_text(FILE *out)
{
  return format_section(out, SECTION_TYPE_TEXT);
}

int asm_format_section_data(FILE *out)
{
  return format_section(out, SECTION_TYPE_DATA);
}
